<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: dlib::impl1::thread_safe_message_queue Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacedlib.html">dlib</a></li><li class="navelem"><b>impl1</b></li><li class="navelem"><a class="el" href="classdlib_1_1impl1_1_1thread__safe__message__queue.html">thread_safe_message_queue</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a> &#124;
<a href="classdlib_1_1impl1_1_1thread__safe__message__queue-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">dlib::impl1::thread_safe_message_queue Class Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="dynheader">
Inheritance diagram for dlib::impl1::thread_safe_message_queue:</div>
<div class="dyncontent">
 <div class="center">
  <img src="classdlib_1_1impl1_1_1thread__safe__message__queue.png" usemap="#dlib::impl1::thread_5Fsafe_5Fmessage_5Fqueue_map" alt=""/>
  <map id="dlib::impl1::thread_5Fsafe_5Fmessage_5Fqueue_map" name="dlib::impl1::thread_5Fsafe_5Fmessage_5Fqueue_map">
<area href="classdlib_1_1noncopyable.html" alt="dlib::noncopyable" shape="rect" coords="0,0,237,24"/>
  </map>
</div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="nested-classes"></a>
Classes</h2></td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structdlib_1_1impl1_1_1thread__safe__message__queue_1_1msg__wrap.html">msg_wrap</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:ab7fd8064a02016282d94e5a5329f8e41"><td class="memItemLeft" align="right" valign="top"><a id="ab7fd8064a02016282d94e5a5329f8e41"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>disable</b> ()</td></tr>
<tr class="separator:ab7fd8064a02016282d94e5a5329f8e41"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a23c343abcfddc016c0696a6e4672bd41"><td class="memItemLeft" align="right" valign="top"><a id="a23c343abcfddc016c0696a6e4672bd41"></a>
unsigned long&#160;</td><td class="memItemRight" valign="bottom"><b>size</b> () const</td></tr>
<tr class="separator:a23c343abcfddc016c0696a6e4672bd41"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a654dcd5d5dc3a87a0851ab44e7fa8d51"><td class="memItemLeft" align="right" valign="top"><a id="a654dcd5d5dc3a87a0851ab44e7fa8d51"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>push_and_consume</b> (<a class="el" href="structdlib_1_1impl1_1_1msg__data.html">msg_data</a> &amp;item)</td></tr>
<tr class="separator:a654dcd5d5dc3a87a0851ab44e7fa8d51"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a19a9082fc6bb9e6cd5faa5c770d45cd2"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1impl1_1_1thread__safe__message__queue.html#a19a9082fc6bb9e6cd5faa5c770d45cd2">pop</a> (<a class="el" href="structdlib_1_1impl1_1_1msg__data.html">msg_data</a> &amp;item)</td></tr>
<tr class="separator:a19a9082fc6bb9e6cd5faa5c770d45cd2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0fab422ba4e9889cfddcc3d0a6025be1"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1impl1_1_1thread__safe__message__queue.html#a0fab422ba4e9889cfddcc3d0a6025be1">pop</a> (<a class="el" href="structdlib_1_1impl1_1_1msg__data.html">msg_data</a> &amp;item, const <a class="el" href="namespacedlib.html#a61113f8b6b3e4ccb66deca9355c8f65d">dlib::uint64</a> &amp;max_epoch)</td></tr>
<tr class="separator:a0fab422ba4e9889cfddcc3d0a6025be1"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr class="memitem:a6871e4195db038c0a84d5696c926b000"><td class="memItemLeft" align="right" valign="top"><a id="a6871e4195db038c0a84d5696c926b000"></a>
std::priority_queue&lt; <a class="el" href="structdlib_1_1impl1_1_1thread__safe__message__queue_1_1msg__wrap.html">msg_wrap</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><b>data</b></td></tr>
<tr class="separator:a6871e4195db038c0a84d5696c926b000"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad6248dddbfd1f67709fc74b8904ec021"><td class="memItemLeft" align="right" valign="top"><a id="ad6248dddbfd1f67709fc74b8904ec021"></a>
<a class="el" href="classdlib_1_1mutex.html">dlib::mutex</a>&#160;</td><td class="memItemRight" valign="bottom"><b>class_mutex</b></td></tr>
<tr class="separator:ad6248dddbfd1f67709fc74b8904ec021"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a785da581407c47b9f6647e4cac06e086"><td class="memItemLeft" align="right" valign="top"><a id="a785da581407c47b9f6647e4cac06e086"></a>
<a class="el" href="classdlib_1_1signaler.html">dlib::signaler</a>&#160;</td><td class="memItemRight" valign="bottom"><b>sig</b></td></tr>
<tr class="separator:a785da581407c47b9f6647e4cac06e086"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acddf42ffe3a0c0304470c5d5177237cb"><td class="memItemLeft" align="right" valign="top"><a id="acddf42ffe3a0c0304470c5d5177237cb"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>disabled</b></td></tr>
<tr class="separator:acddf42ffe3a0c0304470c5d5177237cb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a448efe04c82fb1ba2255880ffcc7edd1"><td class="memItemLeft" align="right" valign="top"><a id="a448efe04c82fb1ba2255880ffcc7edd1"></a>
<a class="el" href="namespacedlib.html#a61113f8b6b3e4ccb66deca9355c8f65d">dlib::uint64</a>&#160;</td><td class="memItemRight" valign="bottom"><b>next_seq_num</b></td></tr>
<tr class="separator:a448efe04c82fb1ba2255880ffcc7edd1"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="inherited"></a>
Additional Inherited Members</h2></td></tr>
<tr class="inherit_header pub_methods_classdlib_1_1noncopyable"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classdlib_1_1noncopyable')"><img src="closed.png" alt="-"/>&#160;Private Member Functions inherited from <a class="el" href="classdlib_1_1noncopyable.html">dlib::noncopyable</a></td></tr>
<tr class="memitem:ac52d1076f79ef032f5ced545bd4cc4f9 inherit pub_methods_classdlib_1_1noncopyable"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1noncopyable.html#ac52d1076f79ef032f5ced545bd4cc4f9">noncopyable</a> ()</td></tr>
<tr class="separator:ac52d1076f79ef032f5ced545bd4cc4f9 inherit pub_methods_classdlib_1_1noncopyable"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a19a9082fc6bb9e6cd5faa5c770d45cd2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a19a9082fc6bb9e6cd5faa5c770d45cd2">&#9670;&nbsp;</a></span>pop() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool dlib::impl1::thread_safe_message_queue::pop </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structdlib_1_1impl1_1_1msg__data.html">msg_data</a> &amp;&#160;</td>
          <td class="paramname"><em>item</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - if (this function returns true) then
        - #item == the next thing from the queue
    - else
        - this object is disabled
</pre><p> ! </p>

</div>
</div>
<a id="a0fab422ba4e9889cfddcc3d0a6025be1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0fab422ba4e9889cfddcc3d0a6025be1">&#9670;&nbsp;</a></span>pop() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool dlib::impl1::thread_safe_message_queue::pop </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structdlib_1_1impl1_1_1msg__data.html">msg_data</a> &amp;&#160;</td>
          <td class="paramname"><em>item</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="namespacedlib.html#a61113f8b6b3e4ccb66deca9355c8f65d">dlib::uint64</a> &amp;&#160;</td>
          <td class="paramname"><em>max_epoch</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - if (this function returns true) then
        - #item == the next thing from the queue that has an epoch &lt;= max_epoch
    - else
        - this object is disabled
</pre><p> ! </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="bsp_2bsp_8h_source.html">bsp/bsp.h</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
